package benefactorservice

import (
	"context"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/benefactore"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) BenefactorExistByID(ctx context.Context, req param.BenefactorExistByIDRequest) (param.BenefactorExistByIDResponse, error) {
	const op = "benefactorservice.BenefactorExistByID"

	isExisted, err := s.repo.IsExistBenefactorByID(ctx, req.ID)
	if err != nil {
		return param.BenefactorExistByIDResponse{}, richerror.New(op).WithErr(err).WithKind(richerror.KindUnexpected)
	}

	return param.BenefactorExistByIDResponse{Existed: isExisted}, nil
}
